<template>
  <div class="container">
    <link rel="stylesheet" href="https://cdnjs.cloudflare.com/ajax/libs/font-awesome/4.7.0/css/font-awesome.min.css">
    <div class="people-list">
      <!-- <div class="search">
       <input type="text" placeholder="search" />
       <i class="fa fa-search"></i>
     </div> -->
      <ul class="list">
        <li class="chat-title" v-for="chat in chatMap" @click="showChat(chat)">
          <img class="avatar" :src="avatar"/>
          <div class="about">
            <div class="name">
              {{ chat.body.message_chat_room_id }}
            </div>
            <div class="status">
              <!--TODO add if-->
              <i class="fa fa-circle online"></i> online
            </div>
          </div>
        </li>
      </ul>
    </div>
    <div class="chat">
      <div class="chat-header">
        <img class="avatar" :src="avatar"/>
        <div class="chat-about">
          <div class="chat-with">
            {{fullName}}
          </div>
          <div class="status">
            <i class="fa fa-circle online"></i> online
          </div>
        </div>
      </div>
      <div class="chat-history">
        <ul>
          <!--TODO fix styles-->
          <div id="current-messages">
            <li v-for="m in getMessages">
              <div v-if="m.message_user.name_sql === fullName" class="message-data float-right">
                <span class="message-data-time">{{m.message_timestamp}}</span>
                <span class="message-data-name">{{fullName}}</span>
                <i class="fa fa-circle me"></i>
                <div class="message my-message float-left">
                  {{ m.message_data.text }}
                </div>
                  <b-img v-if="m.message_data.type === 'Blob'":src="'/dist/'+m.message_data.text" fluid />
              </div>
              <div v-else="" class="message-data float-left">
                <span class="message-data-time">{{m.message_timestamp}}</span>
                <span class="message-data-name">{{m.message_user.name_sql}}</span>
                <i class="fa fa-circle me"></i>
                <div class="message other-message float-right">
                  {{ m.message_data.text }}
                </div>
                        <b-img v-if="m.message_data.type === 'Blob'":src="'/dist/'+m.message_data.text" fluid />
                </div>
            </li>
          </div>
        </ul>
      </div>
      <div class="chat-message clearfix">
        <textarea v-model="messageText" name="message-to-send" id="message-to-send" placeholder="Type your message"
                  rows="3"></textarea>


        <b-button @click="sendMessage()">Send</b-button>

        <div>
           <!-- Accept specific image formats by extension -->
            <b-form-file accept=".jpg, .png, .gif"></b-form-file>
            <!-- Styled -->
            <b-form-file v-model="file" class="mt-3" ref="fileinput" plain></b-form-file>

            <b-button v-model="reset" @click="clearFiles">Reset</b-button>

          </div>

      </div>

    </div>
  </div>

</template>
<script>
  const axios = require('axios');
  export default {
    name: 'messages',
    data: function () {
      return {
        messageText: "",
        messagesForChat: [],
        chatMap: {},
        fullName: sessionStorage.getItem("name") ? sessionStorage.getItem("name") : "Cute Cat",
        user: sessionStorage.getItem("user") ? JSON.parse(sessionStorage.getItem("user")) : {},
        avatar: sessionStorage.getItem("user") && JSON.parse(sessionStorage.getItem("user")).avatar_ref !== "" ? JSON.parse(sessionStorage.getItem("user")).avatar_ref : 'https://i.imgur.com/4AiXzf8.jpg'
      }
    },
    created: function () {
      // TODO multi-chat
      var sock = new WebSocket("wss://" + document.location.host + "/ws");
      sock.onopen = function () {
        console.log("Successfully open connection")
      };
      sock.onerror = function (err) {
        console.log(err);
      };
      var _this = this;
      sock.onmessage = function (event) {
        console.log("New message from chanel");
        console.log(event.data);
        let m = JSON.parse(event.data);
        m.message_timestamp = m.message_timestamp;
        _this.messagesForChat.push(m);
      };

      window.onbeforeunload = function (e) {
        return sock.close();
      };
      this.$store.commit("create_messages", sock)
      this.showChat("hum_chat_room");
    },
    computed: {
      getMessages: function () {
        return this.messagesForChat;
      }
    },
    methods: {

    clearFiles () {
       this.$refs.fileinput.reset();
       this.file = null

      },
    sendMessage: function () {
        let mJson = {
          message_timestamp: (new Date(Date.now()).toLocaleString()),
          message_user: {
            name_sql: this.fullName,
          },
          message_data: {
            text: this.messageText
          }
        };

        if (this.file != null ) {

           mJson.message_data.text =  this.file.name

           mJson.message_data.type =  "Blob"

           this.$store.getters.ws_messages.send(JSON.stringify(mJson));

           this.$store.getters.ws_messages.binaryType = 'arraybuffer';

           this.$store.getters.ws_messages.send(this.file, {binary:true});

           console.log("Sending file name : " + this.file.name )

           this.clearFiles ()


        } else {

         if  (mJson.message_data.text != "" ) {

          this.$store.getters.ws_messages.send(JSON.stringify(mJson));
          this.m.message_data.text = "" ;


        }


        }


        document.getElementsByTagName('textarea')[0].value = "";



      },
      // TODO add request for chats and their messages on page load.
      // showChat(chat) {
      //   messagesForChat = chat;
      // }
    },
    // asyncComputed: {
    //   chats: {
    //     get() {
    //       let messagesAll;
    //       let chatMap;
    //       return axios.get(`http://localhost:8080/messages/`, {
    //         params: {
    //           id: 1
    //         }
    //       })
    //         .then(resp => {
    //           messagesAll = resp.data;
    //           for (let m of messagesAll) {
    //             let chatRoomId = m.body.message_chat_room_id;
    //             if (chatRoomId in chatMap) {
    //               chatMap[chatRoomId].push(m);
    //               continue
    //             }
    //             chatMap[chatRoomId] = [m];
    //           }
    //           console.log(chatMap);
    //         }).then(() => chatMap);
    //     }
    //   }
    // }
  }
</script>

<style scoped>
  .container {
    margin: 0 auto;
    margin-top: 110px;
    max-width: 1000px;
    width: 100%;
    background: #444753;
    border-radius: 5px;
    height: auto;
    min-height: 300px;
    padding: 0px;
    display: flex;

  }

  ul {
    list-style-type: none;
  }

  .people-list {
    /* float:left; */
    width: 400px;
  }

  /* .chat-list {
    margin: 10px 15px;
    padding: 5px;
    display: flex;
  } */
  .avatar {
    width: 50px;
    height: 50px;
    border-radius: 50%;
  }

  .people-list ul {
    padding: 20px;
    height: 770px;
  }

  .people-list ul li {
    padding-bottom: 20px;
    height: 70px;
  }

  .people-list .about {
    padding-left: 8px;
    float: left;
    /* margin-top: 8px; */
  }

  .people-list .name {
    color: white;

  }

  .people-list .status {
    color: #92959E;
  }

  .people-list img {
    float: left;
  }

  .chat {
    width: 100%;
    background: #F2F5F8;
    border-top-right-radius: 5px;
    border-bottom-right-radius: 5px;
    color: rgb(67, 70, 81);
  }

  .chat-header {
    padding: 15px;
    border-bottom: 2px solid white;
    height: auto;
    width: 100%;
    overflow: hidden;
  }

  .chat .chat-header .chat-about {
    float: left;
    padding-left: 10px;
  }

  .chat .chat-header .chat-with {
    font-weight: bold;
    font-size: 16px;
  }

  .chat .chat-history {
    padding: 30px;
    overflow-y: scroll;
    height: auto;
    border-bottom: 2px solid white;
  }

  .chat .chat-history .message-data {
    margin-bottom: 15px;
    float: right;
  }

  .chat .chat-history .message-data-time {
    color: #a8aab1;
    padding-left: 6px;
  }

  .chat .chat-history .other-message {
    background: #94C2ED;
  }

  .my-message {
    background: lightgreen;
  }

  .chat .chat-history .message {
    color: white;
    padding: 18px 20px;
    line-height: 26px;
    font-size: 16px;
    border-radius: 7px;
    margin-bottom: 30px;
    width: 90%;
    position: relative;
  }

  .float-right {
    float: right;
  }

  .float-left {
    float: left;
  }

  .chat .chat-history .my-message {
    background: #86BB71;
  }

  .chat .chat-header img {
    float: left;
  }

  .online, .offline, .me {
    margin-right: 3px;
    font-size: 10px;
  }

  .online {
    color: #86BB71;
  }

  .offline {
    color: #E38968;
  }

  .me {
    color: #94C2ED;
  }

  .chat .chat-message {
    border: #3b4151;
    padding: 30px;
  }

  .chat .chat-message textarea {
    width: 100%;
    border: none;
    padding: 10px 20px;
    font: 14px/22px "Lato", Arial, sans-serif;
    margin-bottom: 10px;
    border-radius: 5px;
    resize: none;
  }

  .chat .chat-message .fa-file-o, .chat .chat-message .fa-file-image-o {
    font-size: 16px;
    color: gray;
    cursor: pointer;
  }

  .chat .chat-message button {
    float: right;
    color: #94C2ED;
    font-size: 16px;
    text-transform: uppercase;
    border: none;
    cursor: pointer;
    font-weight: bold;
    background: #F2F5F8;
  }

  .chat .chat-message button:hover {
    color: #75b1e8;
  }


</style>
